package prog;

import java.io.*;

public class InterpreterAndWriterCallMeFor001239876 {

	public static void write(String k, String p) throws IOException {
	  PrintWriter o = new PrintWriter(p);

	  for (int i = 0; i < 128; i++) {

	    for (int a = 0; a < k.length(); a++) {

	      if (k.charAt(a) == '\\') {
	        a++;

	        if (k.charAt(a) == 'c') {
	            o.print((char) i);
	        } else if (k.charAt(a) == 'a') {
	          o.print(i);
	        } else if (k.charAt(a) == 'b') {
	          String s;
	          if (i < 128) {
	            s = bin(new byte[] {(byte)i});
	          } else {
	            s = Integer.toBinaryString(i);
	          }
	          o.print(s);
	        } else if (k.charAt(a) == 'h') {
	          String s;
	          if (i < 128) {
	            s = hex(new byte[] {(byte)i});
	          } else {
	            s = Integer.toHexString(i);
	          }
	          o.print(s);
	        } else if (k.charAt(a) == 'o') {
	          o.print(Integer.toOctalString(i));
	        } else if (k.charAt(a) == '\\') {
	          o.print('\\');
	        } else {
	          throw new StringIndexOutOfBoundsException();
	        }

	      } else {
	        o.print(k.charAt(a));
	      }

	    }

	    o.println();

	  }

	  o.close();

	}

	public static Trn build(String s) {
	  byte[] b = s.getBytes();

	  return new Trn(s, bin(b), hex(b), octal(b), ascii(b));
	}

	public static Trn buildAscii(String s) {
	  String a = asciiToStr(s.getBytes());
	  byte[] b = a.getBytes();

	  return new Trn(a, bin(b), hex(b), octal(b), s);
	}
	
	public static Trn buildHex(String s) {
		String a = hexToStr(s.getBytes());
		byte[] b = a.getBytes();
		
		return new Trn(a, bin(b), s, octal(b), ascii(b));
	}
	
	public static Trn buildBin(String s) {
		String a = binToStr(s.getBytes());
		byte[] b = a.getBytes();
		
		return new Trn(a, s, hex(b), octal(b), ascii(b));
	}
	
	public static Trn buildOctal(String s) {
		String a = octalToStr(s.getBytes());
		byte[] b = a.getBytes();
		
		return new Trn(a, bin(b), hex(b), s, ascii(b));
	}

	private static String bin(byte[] s) {
	  StringBuilder b = new StringBuilder();
	  String a;

	  for (byte v : s) {
	    if (v < 0) {
	      a = Integer.toBinaryString(-v + 127);
	    } else {
	      a = Integer.toBinaryString(v);
	    }

	    if (a.length() == 7) {
	      b.append("0");
	      b.append(a);
	    } else if (a.length() == 6) {
	      b.append("00");
	      b.append(a);
	    } else if (a.length() == 5) {
	      b.append("000");
	      b.append(a);
	    } else if (a.length() == 4) {
	      b.append("0000");
	      b.append(a);
	    } else if (a.length() == 3) {
	      b.append("00000");
	      b.append(a);
	    } else if (a.length() == 2) {
	      b.append("000000");
	      b.append(a);
	    } else if (a.length() == 1) {
	      b.append("0000000");
	      b.append(a);
	    } else {
	      b.append(a);
	    }

	    b.append(" ");

	  }

	  return rmEnd(b.toString());
	}

	private static String hex(byte[] s) {
	  StringBuilder b = new StringBuilder();
	  String a;

	  for (int i = 0; i < s.length; i++) {
	  	if (s[i] < 0) {
	  		a = Integer.toHexString(-s[i] + 127);
			} else {
				a = Integer.toHexString(s[i]);
			}

	    if (a.length() == 1) {
	      b.append("0");
	    }
	    b.append(a);
	    b.append(" ");

	  }

	  return rmEnd(b.toString());
	}

	private static String octal(byte[] s) {
	  StringBuilder b = new StringBuilder();

	  for (int i = 0; i < s.length; i++) {
	  	if (s[i] < 0) {
	  		b.append(Integer.toOctalString(-s[i] + 127));
			} else {
				b.append(Integer.toOctalString(s[i]));
			}
			b.append(" ");
	  }

	  return rmEnd(b.toString());
	}

	private static String ascii(byte[] s) {
	  StringBuilder b = new StringBuilder();

	  for (int i = 0; i < s.length; i++) {
	  	if (s[i] < 0) {
	  		b.append((int) -s[i] + 127);
			} else {
				b.append(s[i]);
			}
	    b.append(" ");
	  }

	  return rmEnd(b.toString());
	}

	private static String rmEnd(String s) {

	  if (s.length() == 0) {
	    return "";
	  }
	  return s.substring(0, s.length()-1);
	}

	private static String asciiToStr(byte[] s) {
	  byte[] b = new byte[0];
	  int d = 0;
	  int e = 0;

	  for (int i = 0; i < s.length; i++) {

	    if (s[i] == 32) {
	    	e = Integer.parseInt(toString(s, d, i));
				b = push(b, (byte) 0);
				if (e > 127) {
					b[b.length - 1] = (byte) (-e + 127);
				} else {
					b[b.length - 1] = (byte) e;
				}
	      d = i + 1;
	    } else if (i == s.length - 1) {
				e = Integer.parseInt(toString(s, d, i + 1));
				b = push(b, (byte) 0);
				if (e > 127) {
					b[b.length - 1] = (byte) (-e + 127);
				} else {
					b[b.length - 1] = (byte) e;
				}
	    }

	  }

	  return new String(b);
	}

	private static String hexToStr(byte[] s) {
		byte[] b = new byte[0];
		int d = 0;
		int e = 0;

		for (int i = 0; i < s.length; i++) {

			if (s[i] == 32 || i == s.length - 1) {
				if (i == s.length - 1)
					e = parseHex(toString(s, d, i + 1));
				else
					e = parseHex(toString(s, d, i));
				b = push(b, (byte) 0);
				if (e > 127) {
					b[b.length - 1] = (byte) (-e + 127);
				} else {
					b[b.length - 1] = (byte) e;
				}
				
				d = i + 1;
			}

		}

		return new String(b);
	}
	
	private static String binToStr(byte[] s) {
		byte[] b = new byte[0];
		int d = 0;
		int e = 0;
		
		for (int i = 0; i < s.length; i++) {
			
			if (s[i] == 32 || i == s.length - 1) {
				if (i == s.length - 1)
					e = parseBin(toString(s, d, i + 1));
				else
					e = parseBin(toString(s, d, i));
				b = push(b, (byte) 0);
				if (e > 127) {
					b[b.length - 1] = (byte) (-e + 127);
				} else {
					b[b.length - 1] = (byte) e;
				}
				
				d = i + 1;
			}
			
		}
		
		return new String(b);
	}
	
	private static String octalToStr(byte[] s) {
		byte[] b = new byte[0];
		int d = 0;
		int e = 0;
		
		for (int i = 0; i < s.length; i++) {
			
			if (s[i] == 32 || i == s.length - 1) {
				if (i == s.length - 1)
					e = parseOctal(toString(s, d, i + 1));
				else
					e = parseOctal(toString(s, d, i));
				b = push(b, (byte) 0);
				if (e > 127) {
					b[b.length - 1] = (byte) (-e + 127);
				} else {
					b[b.length - 1] = (byte) e;
				}
				
				d = i + 1;
			}
			
		}
		
		return new String(b);
	}
	
	private static int parseOctal(String s) {
		int b = 0;
		
		for (int a = 0; a < s.length(); a++) {
			
			b*=8;
			
			if (s.charAt(a) >= 48 && s.charAt(a) <= 55) {
				
				b += s.charAt(a) - 48;
				
			}
			
		}
		
		return b;
	}
	
	private static int parseBin(String s) {
		int b = 0;
		
		for (int a = 0; a < s.length(); a++) {
			
			b*=2;
			
			if (s.charAt(a) == '1') {
				b++;
			}
			
		}
		
		return b;
	}

	private static int parseHex(String s) {
		int b = 0;

		for (int a = 0; a < s.length(); a++) {
			
			b*=16;
			
			if (s.charAt(a) >= 48 && s.charAt(a) <= 57) {
				b += s.charAt(a) - 48;
			} else if (s.charAt(a) >= 97 && s.charAt(a) <= 102) {
				b += s.charAt(a) - 87;
			}
			
		}

		return b;
	}

	private static byte[] push(byte[] a, byte b) {

		byte[] c = new byte[a.length + 1];

		for (int i = 0; i <= a.length; i++) {

			try {
				c[i] = a[i];
			} catch (ArrayIndexOutOfBoundsException e) {
				c[i] = b;
			}

		}

		return c;
	}

	private static String toString(byte[] b, int s, int e) {
		StringBuilder a = new StringBuilder();

		for (int i = 0; i < e - s; i++) {

			a.append((char) b[i + s]);

		}

		return a.toString();
	}

}